/*
 *   Copyright (C) 2005 by Matthias Jauernig, Michael Lahl                 *
 *   rtc@linux-related.de, DJ-Mayday@web.de                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 */

package prog;

import javax.swing.*;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.*;

/**
 * 
 * @author Mayday
 *
 */

public class GUI extends JFrame {

	private static final long serialVersionUID = 1L;
	
	//Fenster erzeugen
	JPanel prog = new JPanel();
	
	//Men fr Hauptprogramm
	JMenuBar menu = new JMenuBar();
	JMenu datei = new JMenu("Datei");
	JMenu kurven = new JMenu("Kurven");
	JMenuItem info = new JMenuItem("Info");
	JMenuItem exit = new JMenuItem("Beenden");
	JMenuItem peano = new JMenuItem("Peano-Kurve");
	JMenuItem koch = new JMenuItem("Koch-Kurve");
	JMenuItem star = new JMenuItem("Stern-Fraktal");
	public static JLabel main_label1 = new JLabel("     Programm zum darstellen von Fraktalkurven");
	JPanel main_top = new JPanel();
	//Zeichenflche fr die Anzeige der Kurven
	public static ZPanel flaeche = new ZPanel();
	
	public GUI(){
		//Standardkonstruktor
	}
	
	public void init(){
		//Men fr Hauptprogramm zusammenfgen
		datei.add(info);
		datei.addSeparator();
		datei.add(exit);
		kurven.add(peano);
		kurven.add(koch);
		kurven.add(star);
		menu.add(datei);
		menu.add(kurven);
		main_top.setLayout(new GridLayout(1,1));
		main_top.add(menu);
		main_top.add(main_label1);
		
		//Hauptfenster erzeugen und Komponenten hinzufgen
		prog = (JPanel) (this).getContentPane();
		prog.setLayout(new BorderLayout());
		prog.add(main_top, BorderLayout.NORTH);
		prog.add(flaeche, BorderLayout.CENTER);
		
		//Action Methoden
		peano.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				peano(e);
			}
		});
		koch.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				koch(e);
			}
		});
		star.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				star(e);
			}
		});
		exit.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				exit(e);
			}
		});
		info.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				info(e);
			}
		});
	}
	
	public void peano(ActionEvent e){
		Peano_dlg op = new Peano_dlg();
		op.setLocation(200,200);
		op.setTitle("Optionen");
		op.setSize(200,250);
		op.setVisible(true);
	}
	
	public void koch(ActionEvent e){
		Koch_dlg op = new Koch_dlg();
		op.setLocation(200,200);
		op.setTitle("Optionen");
		op.setSize(200,180);
		op.setVisible(true);
	}
	
	public void star(ActionEvent e){
		Star_dlg op = new Star_dlg();
		op.setLocation(200,200);
		op.setTitle("Optionen");
		op.setSize(200,180);
		op.setVisible(true);
	}
		
	public void info(ActionEvent e){
		JOptionPane.showMessageDialog(null,
				"HTWK-Leipzig\n" +
				"Version 1.0\n" +
				"\nProgramm zur Darstellung von Fraktalkurven\n\n" +
				"Author: Michael Lahl, Matthias Jauernig\n" +
				"Projekt im Fach Computergrafik - Prof. Jaeger\n\n" +
				"Kontakt: DJ-Mayday@web.de, rtc@linux-related.de");
	}

	public void exit(ActionEvent e){
		System.exit(0);
	}
}
