/*
 *   Koch_dlg.java	30.5.05
 * 
 *   Copyright (C) 2005 by Matthias Jauernig, Michael Lahl                 *
 *   rtc@linux-related.de, DJ-Mayday@web.de                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 */

package prog;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;

/**
 * 
 * @author Michael Lahl
 * @author Matthias Jauernig
 * 
 * Diese Klasse erweitert die Klasse GUI um den Optionen - Frame (Dialog)
 * fr die Erstellung einer Kochkurve. Durch diesen wird festgelegt vom Benutzer
 * welche Art von Kochkurve (Schneeflocke oder Einfache) gezeichnet werden soll. Ausserdem wird dir zu zeichnende
 * Ordnung vom Benutzer festgelegt (durch Eingabe).
 * 
 * $Id: Koch_dlg.java,v 1.4 2005/06/21 07:41:52 mlahl Exp $
 */
public class Koch_dlg extends GUI{
	
	private static final long serialVersionUID = 1L;
	CheckboxGroup op_group = new CheckboxGroup();
	Checkbox op_option1 = new Checkbox("Einfache Kochkurve", op_group, true);
	Checkbox op_option2 = new Checkbox("Kochsche Schneeflocke", op_group, false);
	JTextField op_text = new JTextField("0", 3);
	JLabel op_label1 = new JLabel("Ordnung eingeben:");
	/**
	 * Erstellung des Dialogs durch das Zusammensetzen der AWT Komponenten.
	 */
	public Koch_dlg(){
		GridBagLayout grid = new GridBagLayout();
		GridBagConstraints cons = new GridBagConstraints();
		setLayout(grid);
		
		buildConstraints(cons, 0, 0, 1, 1, 60, 20);
		cons.anchor = GridBagConstraints.SOUTH;
		grid.setConstraints(op_label1, cons);
		add(op_label1);
		
		buildConstraints(cons, 1, 0, 1, 1, 40, 20);
		cons.anchor = GridBagConstraints.SOUTH;
		grid.setConstraints(op_text, cons);
		add(op_text);
		
		buildConstraints(cons, 0, 1, 2, 1, 100, 20);
		cons.anchor = GridBagConstraints.SOUTH;
		JLabel op_label2 = new JLabel("Koch - Einstellungen");
		grid.setConstraints(op_label2, cons);
		add(op_label2);
		
		buildConstraints(cons, 0, 2, 2, 1, 100, 20);
		cons.anchor = GridBagConstraints.SOUTHWEST;
		grid.setConstraints(op_option1, cons);
		add(op_option1);
		
		buildConstraints(cons, 0, 3, 2, 1, 100, 20);
		cons.anchor = GridBagConstraints.NORTHWEST;
		grid.setConstraints(op_option2, cons);
		add(op_option2);
		
		buildConstraints(cons, 0, 4, 2, 1, 100, 25);
		cons.anchor = GridBagConstraints.CENTER;
		JPanel op_buttons = new JPanel();
		JButton op_ok = new JButton("OK");
		JButton op_abbr = new JButton("Abbruch");
		op_buttons.add(op_ok);
		op_buttons.add(op_abbr);
		grid.setConstraints(op_buttons, cons);
		add(op_buttons);
		
		op_ok.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				ok(e);
			}
		});
		op_abbr.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				abbruch(e);
			}
		});
	}
	
	/**
	 * 
	 * Methode zum festlegen der Parameter fr jede Zelle auf dem Dialog.
	 * 
	 * @param con bergebene GridBagConstraint f welches die Werte gesetzt werden soll
	 * @param conx x Wert der Zelle
	 * @param cony y Wert der Zelle
	 * @param conw Umfasst conw Spalten
	 * @param conh Umfasst conh Zeilen
	 * @param wx x Proportion festlegen
	 * @param wy y Proportion festlegen
	 */
	void buildConstraints(GridBagConstraints con, int conx, int cony, int conw, int conh, int wx, int wy){
		con.gridx = conx;		//x Wert der Zelle
		con.gridy = cony;		//y Wert der Zelle
		con.gridwidth = conw;	//Umfasst conw Spalten
		con.gridheight = conh;	//Umfasst conh Zeilen
		con.weightx = wx;		//x Proportion festlegen
		con.weighty = wy;		//y Proportion festlegen
	}
	
	/**
	 * Ereignisbehandlungsmethode fr den OK Button. Diese Methode prft
	 * die Eingabe im Diealog und gibt die Informationen an die Klasse Koch
	 * weiter. 
	 * 
	 * @param e Ereignis
	 */
	public void ok(ActionEvent e){
		ZPanel.getord = Integer.parseInt(op_text.getText());
		
		if(ZPanel.getord < 0){
			JOptionPane.showMessageDialog(null, "Bitte einen Wert >= 0 eingeben!");
		}else{
			if(op_option1.getState()){
				ZPanel.wahl = 2;
				GUI.main_label1.setText("     KOCH-KURVE, Ordnung = "+ZPanel.getord);
			}
			if(op_option2.getState()){
				ZPanel.wahl = 3;
				GUI.main_label1.setText("     KOCHSCHE-SCHNEEFLOCKE, Ordnung = "+ZPanel.getord);
			}
			flaeche.repaint();
			dispose();
		}
	}
	
	/**
	 * Ereignisbehandlungsmethode fr den Abbruch Button.
	 * 
	 * @param e Ereignis
	 */
	public void abbruch(ActionEvent e){
		dispose();
	}
}
