/*
 *   Copyright (C) 2005 by Matthias Jauernig, Michael Lahl                 *
 *   rtc@linux-related.de, DJ-Mayday@web.de                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 */

package prog;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;

/**
 * 
 * @author Michael Lahl
 * @author Matthias Jauernig
 *	
 *	Peano_dlg stellt ein Optionenfenster fr die Erstellung einer
 *	Peanokurve auf einem ZPanel zur Verfgung.
 *
 *	$Id: Peano_dlg.java,v 1.4 2005/06/21 07:41:52 mlahl Exp $
 */

public class Peano_dlg extends GUI {
	
	private static final long serialVersionUID = 1L;
	//Checkboxes fr Kanten initialisieren
	JCheckBox op_c1 = new JCheckBox("1");
	JCheckBox op_c2 = new JCheckBox("2");
	JCheckBox op_c3 = new JCheckBox("3");
	JCheckBox op_c4 = new JCheckBox("4");
	JCheckBox op_c5 = new JCheckBox("5");
	JCheckBox op_c6 = new JCheckBox("6");
	JCheckBox op_c7 = new JCheckBox("7");
	JCheckBox op_c8 = new JCheckBox("8");
	JCheckBox op_c9 = new JCheckBox("9");
	//Textfeld fr die Eingabe der Ordnung
	JTextField op_text = new JTextField("0",3);
	
	/**
	 * Standardkonstruktor
	 * Dieser dient zur Erstllung des gewnschten Dialog - Fensters.
	 */
	public Peano_dlg(){
		//Standardkonstruktor zur Erstellung eines Optionen-Frames
		//Objekte auf dem Frame anordnen mit GridBagLayout()
		GridBagLayout grid = new GridBagLayout();
		GridBagConstraints cons = new GridBagConstraints();
		setLayout(grid);
		
		buildConstraints(cons, 0, 0, 1, 1, 60, 20);
		cons.anchor = GridBagConstraints.SOUTH;
		JLabel op_label1 = new JLabel("Ordnung eingeben:");
		grid.setConstraints(op_label1, cons);
		add(op_label1);

		buildConstraints(cons, 1, 0, 1, 1, 40, 20);
		cons.anchor = GridBagConstraints.SOUTH;
		grid.setConstraints(op_text, cons);
		add(op_text);

		buildConstraints(cons, 0, 1, 2, 1, 100, 20);
		cons.anchor = GridBagConstraints.SOUTH;
		JLabel op_label2 = new JLabel("Peano - Einstellungen");
		grid.setConstraints(op_label2, cons);
		add(op_label2);
		
		buildConstraints(cons, 0, 2, 1, 1, 100, 40);
		cons.anchor = GridBagConstraints.CENTER;
		JPanel check = new JPanel();
		check.setLayout(new GridLayout(3,3, 10,10));
		check.add(op_c1);
		check.add(op_c2);
		check.add(op_c3);
		check.add(op_c4);
		check.add(op_c5);
		check.add(op_c6);
		check.add(op_c7);
		check.add(op_c8);
		check.add(op_c9);
		grid.setConstraints(check, cons);
		add(check);
		
		buildConstraints(cons, 1, 2, 1, 1, 100, 40);
		cons.anchor = GridBagConstraints.CENTER;
		JPanel bild = new JPanel();
		
		grid.setConstraints(bild, cons);
		add(check);
		
		buildConstraints(cons, 0, 3, 2, 1, 100, 20);
		cons.anchor = GridBagConstraints.CENTER;
		JPanel op_buttons = new JPanel();
		JButton op_ok = new JButton("OK");
		JButton op_abbr = new JButton("Abbruch");
		op_buttons.add(op_ok);
		op_buttons.add(op_abbr);
		grid.setConstraints(op_buttons, cons);
		add(op_buttons);		
		setCheckBox();
		
		//ActionListener fr OK und ABBRUCH Button
		op_ok.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				ok(e);
			}
		});
		op_abbr.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				abbruch(e);
			}
		});
	}
	
	/**
	 * 
	 * Methode zum festlegen der Parameter fr jede Zelle auf dem Dialog.
	 * 
	 * @param con bergebene GridBagConstraint f welches die Werte gesetzt werden soll
	 * @param conx x Wert der Zelle
	 * @param cony y Wert der Zelle
	 * @param conw Umfasst conw Spalten
	 * @param conh Umfasst conh Zeilen
	 * @param wx x Proportion festlegen
	 * @param wy y Proportion festlegen
	 */
	void buildConstraints(GridBagConstraints con, int conx, int cony, int conw, int conh, int wx, int wy){
		con.gridx = conx;		//x Wert der Zelle
		con.gridy = cony;		//y Wert der Zelle
		con.gridwidth = conw;	//Umfasst conw Spalten
		con.gridheight = conh;	//Umfasst conh Zeilen
		con.weightx = wx;		//x Proportion festlegen
		con.weighty = wy;		//y Proportion festlegen
	}
	
	/**
	 * Ereignisbehandlungsmethode fr den OK Button. Diese Methode prft
	 * die Eingabe im Diealog und gibt die Informationen an die Klasse Peano
	 * weiter. 
	 * 
	 * @param e Ereignis
	 */
	public void ok(ActionEvent e){
		//Eingegebende Ordnung holen
		ZPanel.getord = Integer.parseInt(op_text.getText());
		//Einnzeln die Checkbuttons durchgehen und schauen ob
		//Aktiviert oder nicht, Ergebnis in Array speichern
		if(op_c1.isSelected()){
			Peano.visible[0] = true;
		}else{
			Peano.visible[0] = false;
		}
		if(op_c2.isSelected()){
			Peano.visible[1] = true;
		}else{
			Peano.visible[1] = false;
		}
		if(op_c3.isSelected()){
			Peano.visible[2] = true;
		}else{
			Peano.visible[2] = false;
		}
		if(op_c4.isSelected()){
			Peano.visible[3] = true;
		}else{
			Peano.visible[3] = false;
		}
		if(op_c5.isSelected()){
			Peano.visible[4] = true;
		}else{
			Peano.visible[4] = false;
		}
		if(op_c6.isSelected()){
			Peano.visible[5] = true;
		}else{
			Peano.visible[5] = false;
		}
		if(op_c7.isSelected()){
			Peano.visible[6] = true;
		}else{
			Peano.visible[6] = false;
		}
		if(op_c8.isSelected()){
			Peano.visible[7] = true;
		}else{
			Peano.visible[7] = false;
		}
		if(op_c9.isSelected()){
			Peano.visible[8] = true;
		}else{
			Peano.visible[8] = false;
		}
		
		if(ZPanel.getord < 0){
			JOptionPane.showMessageDialog(null, "Bitte einen Wert >= 0 eingeben!");
		}else{
			ZPanel.wahl = 1;
			GUI.main_label1.setText("     PEANO-KURVE, Ordnung = "+ZPanel.getord);
			flaeche.repaint();
			dispose();
		}
	}
	/**
	 * Ereignisbehandlungsmethode fr den Abbruch Button.
	 * 
	 * @param e Ereignis
	 */
	public void abbruch(ActionEvent e){
		dispose();
	}
	
	/**
	 * Initialisierungsmethode fr die Checkboxes. Setzt alle auf <code>true</code>.
	 */
	public void setCheckBox(){
		op_c1.setSelected(true);
		op_c2.setSelected(true);
		op_c3.setSelected(true);
		op_c4.setSelected(true);
		op_c5.setSelected(true);
		op_c6.setSelected(true);
		op_c7.setSelected(true);
		op_c8.setSelected(true);
		op_c9.setSelected(true);
	}
}
