/*	
 * 	 ZPanel.java	30.5.2005
 *
 *   Copyright (C) 2005 by Matthias Jauernig, Michael Lahl                 *
 *   rtc@linux-related.de, DJ-Mayday@web.de                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 */

package prog;

import javax.swing.*;
import java.awt.*;

/**
 * 
 * @author Michael Lahl
 * @author Matthias Jauernig
 * 
 * Klasse ZPanel erweitert die Klasse JPanel. Mit ihr wird eine Oberflche
 * erstellt auf der die Kurven gezeichnet werden.
 * 
 * $Id: ZPanel.java,v 1.6 2005/06/21 08:51:21 mjauerni Exp $
 * 
 * @param <code>public static int getord</code> : enthlt eingegebene Ordnung
 * @param <code>public static int wahl</code> : enthlt einen Wert der Menge {0-3}
 * @param <code>int ordnung</code> : enthlt die aktuelle Ordnung der Rekursion
 */

public class ZPanel extends JPanel {

	private static final long serialVersionUID = 1L;
	public static int getord = 0, wahl = 0;
	int ordnung = 0;
	
	/**
	 * Standardkonstruktor zur Erstellung eines <code>ZPanels</code> mit einer
	 * weien Hintergrundfarbe.
	 */
	public ZPanel(){
		//Hintergrundfarbe auf Wei setzen
		this.setBackground(Color.white);
	}
	
	/**
	 * Die Methode <code>paint()</code> wird berschrieben. Mit ihr werden die
	 * veschiedenen Kurven wie Kochkurve, Kochsche Schneeflocke oder Peanokurve
	 * auf dem <code>ZPanel</code> gezeichnet.
	 * 
	 * @param <code>Graphics screen</code> : Flche fr grafische Zeichnungen
	 */	
	public void paint(Graphics screen){
		super.paint(screen);
		//Umwandeln der grafischen Flche in eine Graphics2D Komponente
		Graphics2D g2D = (Graphics2D)screen;
		//Objekte zur Erstellung der Kurven erzeugen
		Peano p = new Peano();
		Koch k1 = new Koch();
		Star s = new Star();
		//Abfragen der jeweiligen Eingabe durch den Benutzer
		switch(wahl){
			case 1: //PEANO-KURVE zeichnen
					p.zeichnen(g2D, ordnung, getord, 200, 100, 400, 400);
					break;
			case 2: //KOCH-KURVE zeichnen
					k1.zeichnen(g2D, ordnung, getord, 25, 200, GUI.flaeche.getWidth()-25, 200);
					break;
			case 3: //KOCH'SCHE SCHNEEFLOCKE zeicnen
					//Basis des Dreiecks
					k1.zeichnen(g2D, ordnung, getord, 175, GUI.flaeche.getHeight()-200, GUI.flaeche.getWidth()-175, GUI.flaeche.getHeight()-200);
					//rechte Seite des Dreiecks
					k1.zeichnen(g2D, ordnung, getord, GUI.flaeche.getWidth()-175, GUI.flaeche.getHeight()-200, GUI.flaeche.getWidth()-(GUI.flaeche.getWidth()/2), 10);
					//linke Seite des Dreiecks
					k1.zeichnen(g2D, ordnung, getord, GUI.flaeche.getWidth()-(GUI.flaeche.getWidth()/2), 10, 175, GUI.flaeche.getHeight()-200);
					break;
			case 4: //Star-Fraktal zeichnen
					s.zeichnen(g2D, getord, GUI.flaeche.getWidth()/2, GUI.flaeche.getHeight()/2, Math.min(GUI.flaeche.getWidth(),GUI.flaeche.getHeight())/4);
		}
	}
}
